/*
 * Copyright (c) 2020. Red Hat, Inc. and/or its affiliates.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.drools.core.base;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.Collection;
import java.util.Map;

import org.kie.internal.builder.KnowledgeBuilderResult;

public interface ClassFieldInspector {
    Map<String, Integer> getFieldNames();

    boolean isNonGetter( String name );

    Map<String, Field> getFieldTypesField();

    Map<String, Class< ? >> getFieldTypes();

    Class< ? > getFieldType(String name);

    Map<String, Method> getGetterMethods();

    Map<String, Method> getSetterMethods();

    Collection<KnowledgeBuilderResult> getInspectionResults( String fieldName );
}
