/*
 * Copyright 2010 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.drools.core.runtime.help.impl;

import org.kie.internal.runtime.helper.BatchExecutionHelperProvider;

import com.thoughtworks.xstream.XStream;

import static org.kie.soup.xstream.XStreamUtils.createTrustingXStream;

public class BatchExecutionHelperProviderImpl
    implements
    BatchExecutionHelperProvider {

    public XStream newXStreamMarshaller() {
        XStream xstream = createTrustingXStream();
        return newXStreamMarshaller(xstream);
    }

    public XStream newJSonMarshaller() {
        return XStreamJSon.newJSonMarshaller();
    }

    public XStream newXStreamMarshaller(XStream xstream) {
        return XStreamXML.newXStreamMarshaller(xstream);
    }
    
}
